#                                                       -*- Autoconf -*-

# HAVM_PROG(PROGRAM, REQUIRED-VERSION, VARIABLE, DESCRIPTION)
# -----------------------------------------------------------
# Check whether PROGRAM version is greater or equal to REQUIRED-VERSION.
# Define VARIABLE as an Autoconf variable for this program, along with
# its DESCRIPTION.
AC_DEFUN([HAVM_PROG],
	 [AC_REQUIRE([AS_VERSION_COMPARE])dnl
	  AC_ARG_VAR([$3], [$4])
	  AC_CHECK_PROGS([$3], [$1])
	  [required_version="`echo \"$2\" | grep '^[0-9][0-9.]*$'`"]
	  if test -z "$required_version" ; then
	    AC_MSG_ERROR([[This macro requires a [0-9.]+ argument]])
	  fi
	  if test -n "$$3" ; then
	    AC_CACHE_CHECK([for $1 >= $required_version],
	      [ac_cv_$1_version],
	      [[actual_version=`$$3 --version | \
	          sed 's/^[^0-9]*\([0-9][0-9.]*[0-9]\).*$/\1/'`]
	      if test -z "$actual_version" ; then
	      	ac_cv_$1_version=no
	      else
		ac_cv_$1_version=yes
	      fi
	      if test x$ac_cv_$1_version = xyes ; then
	        AS_VERSION_COMPARE([$actual_version], [$required_version],
		  [ac_cv_$1_version=no],
		  [ac_cv_$1_version=yes],
		  [ac_cv_$1_version=yes])])
	      fi
	  fi
	  if test x$ac_cv_$1_version != xyes; then
	    AC_MSG_ERROR([$1 $required_version or newer is required])
	  fi
])
